c
C------------------------------------------------------------------
C The following files are copied from Genesis because they are 
C called from "magfield.f":
C PRINTERR from output.f
C LAST from output.f (only the main close is taken, all others are commented out
C CLOSEFILE from output.f
C OPENTEXTFILE from output.f
C OPENOUTPUTFILE from output.f
C-------------------------------------------------------------------
      function printerr(ierr,text)
c     ========================================================
c     print error messages
c     --------------------------------------------------------
      
      include 'genesis.def'
      include 'io.cmn'

      integer ierr
      character*(*) text

      printerr=ierr
      if (ierr.ge.0) return
      goto (10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,
     c      25,26,27,28,29,30,31,32,33)
     c     ,iabs(ierr)
 10   write(nlog,100) text
      return
 11   write(nlog,101) text
      return
 12   write(nlog,102) text
      return
 13   write(nlog,103) text
      return
 14   write(nlog,104) text
      return
 15   write(nlog,105) text
      return
 16   write(nlog,106) text
      return
 17   write(nlog,107) text
      return
 18   write(nlog,108) text
      return
 19   write(nlog,109) text
      return
 20   write(nlog,110) text
      return
 21   write(nlog,111) text
      return
 22   write(nlog,112) text
      return
 23   write(nlog,113) text
      return
 24   write(nlog,114) text
      return
 25   write(nlog,115) text
      return
 26   write(nlog,116) text
      return
 27   write(nlog,117) text
      return
 28   write(nlog,118) text
      return
 29   write(nlog,119) text
      return
 30   write(nlog,120) text
      return
 31   write(nlog,121) text
      return
 32   write(nlog,122) text
      return
 33   write(nlog,123) text
      return
c
c     format statements
c
 100  format('***  File-error: ',a,/,
     c       '***  cannot be opened')
 101  format('***  File-error: ',a,/,
     c       '***  cannot be accessed')
 102  format('***  File-error: ',a,/,
     c       '***  cannot be opened',/,
     c       '***  creating template file: template.in')
 103  format('***  File-error: ',a,/,
     c       '***  error in namelise $newrun')
 104  format('***  Scan-warning: conflict with ITDP',/,
     c       '***  using scan-feature',a)
 105  format('***  Scan-warning: conflict with BEAMFILE',/,
     c       '***  ignoring BEAMFILE: ',a)
 106  format('***  Beamfile-warning: size exceeds NSMAX',/,
     c       '***  ',a)
 107  format('***  Input-error: ',a)
 108  format('***  Input-warning: ',a)
 109  format('***  Input-error: cannot convert to individiual input',/,
     c       '***  ',a)
 110  format('***  Numerical-error: boundary exceeded of',a,/,
     c       '***  ignoring exceeding elements')
 111  format('***  Round-warning: section not multiple of XLAMD',/,
     c       '***  MAGINFILE:',a)    
 112  format('***  Extrapolation-warning: exceeding time window of',/,
     c       '***  BEAMFILE by:',a)
 113  format('***  Scan-error: conflict with MAGINFILE:',a,/,
     c       '***  disabling scan-feature') 
 114  format('***  Scan-error: conflict with MAGOUTFILE:',a,/,
     c       '***  disabling scan-feature')
 115  format('***  Warning: particle loss of ',a,'%')
 116  format('***  Warning: external magnet definition too short for '
     c       ,a)
 117  format('***  Error: invalid filename:',a)
 118  format('***  File-error: cannot read from FIELDFILE:',a)
 119  format('***  Warning: ',a)
 120  format('***  Error: cannot run in background mode.',/,
     c       '***  information needed for ',a)
 121  format('***  Error: CRTIME cannot hold slippage field.',/,
     c       '***  see manual for allocating more memory',a)
 122  format('***  Error: unphysical parameter for loading',/,
     c       '***  ',a)
 123  format('***  ',a)
      end

      subroutine last
c     ==================================================================
c     called at end of run.
c     closes all files, which must stay open during the run
c     ------------------------------------------------------------------
c
      include 'genesis.def'
      include 'io.cmn'
c
      write (nlog,100)
      call closefile(nout)   !standard output
cb      call closefile(nfld)   !field output
cb      call closefile(npar)   !particle output 
cb      call closefile(nfin)   !field input
cb      call closefile(npin)   !particle input
cb      call closefile(ndump)  !dumped field
cb      call closefile(ndmp2)  !dumped particle 
cb      call closefile(ndis)   !input distribution
cb      call closetimerec
c      
      write (nlog,200) !genesis has finished
c
      if (nlog.ne.6)  call closefile(nlog)   !log file
      stop
c
 100  format('***  closing files')
 200  format(/,'Genesis run has finished',/,
     c         '------------------------') 
      end     !last
c
      subroutine closefile(nio)
c     =================================================================
c     closing file
c     ---------------------------------------------------------------
c
      logical isop
c
      if (nio.gt.6) then
        inquire(nio,opened=isop) 
        if (isop) close(nio)                   !close history file
      endif  
      return
      end ! of closefile
c
      function opentextfile(file,status,nio)
c     ==================================================================
c     open ascii file (sequential access)
c     ------------------------------------------------------------------ 
c    
c
      include 'genesis.def'
c
      character*(*) file,status
      integer nio



      opentextfile=nio
      open(nio,file=file,status=status,err=100)
      return
 100  opentextfile=printerr(erropen,file)
      return
      end ! of opentextfile

      function openoutputfile(ierror)
c     ==================================================================
c     initial output of genesis.
c     ------------------------------------------------------------------
c
      include 'genesis.def'
      include 'input.cmn'
      include 'io.cmn'
c
      integer ierror,i,isdefined,istr
 
      isdefined=0
      if (ierror.eq.erropenin) then 
        outputfile='template.in'   !input file not file -> generate template
      else
        isdefined=1 
         if (index(outputfile,' ').eq.1) then    !no outputfile defined -> ask for it
            isdefined=0
            if (ilog.ne.0) then
              i=printerr(errrequest,'OUTPUTFILE')   !interaction required
              call last
            endif
 1          write(6,100) 
            read(5,105) outputfile       !output file name not defined
            if (index(outputfile,' ').eq.1) then
               i=printerr(errinvalname,outputfile)
               goto 1
            endif   
         endif                           !ask for output filename  
      endif
c
      nout=9
      openoutputfile=noerr
      open(nout,file=outputfile,err=10,status='unknown') !open input file.
c       
      if (ierror.eq.noerr)  then
        write(nout,110) genver,platf,inputfile
      endif

c
c     dump input parmeters
c
      write(nout,1000)
     +          aw0,xkx,xky,(wcoefz(i),i=1,3),xlamd,fbess0,delaw,
     +          iertyp,iwityp,awd,awx,awy,iseed,
     +          npart,gamma0,delgam,rxbeam,rybeam,alphax,alphay,
     +          emitx,emity,xbeam,ybeam,pxbeam,pybeam,
     +          conditx,condity,bunch,bunchphase,emod,emodphase,     
     +          xlamds,prad0,zrayl,zwaist
      write(nout,1001)
     +          ncar,lbc,rmax0,dgrid,nscr,nscz,nptr,
     +          nwig,zsep,delz,nsec,iorb,zstop,magin,magout,
     +          quadf,quadd,fl,dl,drl,f1st,qfdx,qfdy,solen,sl,
     +          ildgam,ildpsi,ildx,ildy,ildpx,ildpy,itgaus,nbins,
     +          igamgaus,     
     +          (lout(i),i=1,14+2*nhmax)
      write(nout,1002)
     +          iphsty,ishsty,ippart,ispart,ipradi,isradi,
     +          idump,iotail,nharm,   
     +          curpeak,curlen,ntail,nslice,shotnoise,isntyp,iall,itdp,
     +          ipseed,iscan,nscan,svar,isravg,isrsig,cuttail,eloss,
     +          version,ndcut  
      write(nout,1003)
     +          idmpfld,idmppar,ilog,ffspec
c
      istr=strlen(beamfile)
      if (istr.gt.1) 
     c   write(nout,1010) 'beamfile =',beamfile(1:istr)
      istr=strlen(fieldfile)
      if (istr.gt.1) 
     c   write(nout,1010) 'fieldfile =',fieldfile(1:istr)
      istr=strlen(scan)
      if (istr.gt.1) 
     c   write(nout,1010) 'scan =',scan(1:istr)
      istr=strlen(outputfile)
      if ((istr.gt.1).and.(isdefined.ne.0)) 
     c   write(nout,1010) 'outputfile =',outputfile(1:istr)
      istr=strlen(maginfile)
      if (istr.gt.1) 
     c   write(nout,1010) 'maginfile =',maginfile(1:istr)
      istr=strlen(magoutfile)
      if (istr.gt.1) 
     c   write(nout,1010) 'magoutfile =',magoutfile(1:istr)
      istr=strlen(partfile)
      if (istr.gt.1) 
     c   write(nout,1010) 'partfile =',partfile(1:istr)
      istr=strlen(distfile)
      if (istr.gt.1) 
     c   write(nout,1010) 'distfile =',distfile(1:istr)
      istr=strlen(filetype)
      if (istr.gt.1) 
     c   write(nout,1010) 'filetype =',filetype(1:istr)
      write(nout,1020) '$end'
c
      return 
c
 10   openoutputfile=printerr(erropen,outputfile)
      return
c
c     format statement 
c
 100  format('Please enter output file name ')
 105  format(a30)
 110  format(  '- - - - - - - - - - - - - - - - - - - - - - - -'
     c         '-----------------------------------------------',/,
     c         'Genesis 1.3 output start',/,
     c         '(Version ',f3.1,' ',a,')',/,/,
     c         'Input file name:  ',a30,/)
c
 1000 format(1x,'$newrun',/, 
     +       1x,'aw0   =',1pd14.6,/,
     +       1x,'xkx   =',1pd14.6,/,
     +       1x,'xky   =',1pd14.6,/,
     +       1x,'wcoefz=',3(1pd14.6,1x),/,
     +       1x,'xlamd =',1pd14.6,/,
     +       1x,'fbess0=',1pd14.6,/,
     +       1x,'delaw =',1pd14.6,/,
     +       1x,'iertyp=',i5,/,
     +       1x,'iwityp=',i5,/,
     +       1x,'awd   =',1pd14.6,/,
     +       1x,'awx   =',1pd14.6,/,
     +       1x,'awy   =',1pd14.6,/,
     +       1x,'iseed =',i5,/,
     +       1x,'npart =',i5,/,
     +       1x,'gamma0=',1pd14.6,/,
     +       1x,'delgam=',1pd14.6,/,
     +       1x,'rxbeam=',1pd14.6,/,
     +       1x,'rybeam=',1pd14.6,/,
     +       1x,'alphax=',1pd14.6,/,
     +       1x,'alphay=',1pd14.6,/,
     +       1x,'emitx =',1pd14.6,/,
     +       1x,'emity =',1pd14.6,/,
     +       1x,'xbeam =',1pd14.6,/,
     +       1x,'ybeam =',1pd14.6,/,
     +       1x,'pxbeam=',1pd14.6,/,
     +       1x,'pybeam=',1pd14.6,/,
     +       1x,'conditx =',1pd14.6,/,
     +       1x,'condity =',1pd14.6,/,
     +       1x,'bunch =',1pd14.6,/,
     +       1x,'bunchphase =',1pd14.6,/,
     +       1x,'emod =',1pd14.6,/,
     +       1x,'emodphase =',1pd14.6,/,     
     +       1x,'xlamds=',1pd14.6,/,
     +       1x,'prad0 =',1pd14.6,/,
     +       1x,'zrayl =',1pd14.6,/,
     +       1x,'zwaist=',1pd14.6)
 1001 format(1x,'ncar  =',i5,/,
     +       1x,'lbc   =',i5,/,
     +       1x,'rmax0 =',1pd14.6,/,
     +       1x,'dgrid =',1pd14.6,/,
     +       1x,'nscr  =',i5,/,
     +       1x,'nscz  =',i5,/,
     +       1x,'nptr  =',i5,/,
     +       1x,'nwig  =',i5,/,
     +       1x,'zsep  =',1pd14.6,/,
     +       1x,'delz  =',1pd14.6,/,
     +       1x,'nsec  =',i5,/,
     +       1x,'iorb  =',i5,/,
     +       1x,'zstop =',1pd14.6,/,
     +       1x,'magin =',i5,/,
     +       1x,'magout=',i5,/,
     +       1x,'quadf =',1pd14.6,/,
     +       1x,'quadd =',1pd14.6,/,
     +       1x,'fl    =',1pd14.6,/,
     +       1x,'dl    =',1pd14.6,/,
     +       1x,'drl   =',1pd14.6,/,
     +       1x,'f1st  =',1pd14.6,/,
     +       1x,'qfdx  =',1pd14.6,/,
     +       1x,'qfdy  =',1pd14.6,/,
     +       1x,'solen =',1pd14.6,/,
     +       1x,'sl    =',1pd14.6,/,
     +       1x,'ildgam=',i5,/,
     +       1x,'ildpsi=',i5,/,
     +       1x,'ildx  =',i5,/,
     +       1x,'ildy  =',i5,/,
     +       1x,'ildpx =',i5,/,
     +       1x,'ildpy =',i5,/,
     +       1x,'itgaus=',i5,/,
     +       1x,'nbins =',i5,/,
     +       1x,'igamgaus =',i5,/,     
     +       1x,'lout  =',25(1x,i1))
 1002 format(1x,'iphsty=',i5,/,
     +       1x,'ishsty=',i5,/,
     +       1x,'ippart=',i5,/,
     +       1x,'ispart=',i5,/,
     +       1x,'ipradi=',i5,/,
     +       1x,'isradi=',i5,/,
     +       1x,'idump =',i5,/,
     +       1x,'iotail=',i5,/,
     +       1x,'nharm =',i5,/,
     +       1x,'curpeak=',1pd14.6,/,
     +       1x,'curlen=',1pd14.6,/,
     +       1x,'ntail =',i5,/,
     +       1x,'nslice=',i5,/,
     +       1x,'shotnoise=',1pd14.6,/,
     +       1x,'isntyp=',i5,/,
     +       1x,'iall  =',i5,/,
     +       1x,'itdp  =',i5,/,
     +       1x,'ipseed=',i5,/,
     +       1x,'iscan =',i5,/,
     +       1x,'nscan =',i5,/,
     +       1x,'svar  =',1pd14.6,/,
     +       1x,'isravg=',i5,/,
     +       1x,'isrsig=',i5,/,
     +       1x,'cuttail=',1pd14.6,/,
     +       1x,'eloss =',1pd14.6,/,
     +       1x,'version=',1pd14.6,/,
     +       1x,'ndcut =',i5)
 1003 format(1x,'idmpfld=',i5,/,
     +       1x,'idmppar=',i5,/,
     +       1x,'ilog  =',i5,/,
     +       1x,'ffspec=',i5)  
 1010 format(1x,a,1h',a,1h')
 1020 format(1x,a4)
      end !of outheader
c
